# Localization infrastructure developed by Vijit Singh under the guidance of Manusheel Gupta, with pointers from Dan Bricklin.
# For getting involved in the development of SocialCalc on Sugar, or on any questions related to it, please e-mail at socialcalc<dot>sugar<at>seeta<dot>in. 
# For posting a feature request/bug, please use http://testtrack.seeta.in. 
# File author - Vijit Singh

### file to contain the localized strings
# -*- coding: utf-8 -*-
from gettext import gettext as _

localized_strings={}

def add_localized_strings():

   #localized_strings['textdatadefaulttype']=_("t")
   localized_strings['s_BrowserNotSupported']=_("Browser not supported.")
   localized_strings['s_InternalError']=_( "Internal SocialCalc error (probably an internal bug):")
   localized_strings['s_pssUnknownColType']=_("Unknown col type item")
   localized_strings['s_pssUnknownRowType']=_("Unknown row type item")
   localized_strings['s_pssUnknownLineType']=_("Unknown line type")
   localized_strings['s_cfspUnknownCellType']=_("Unknown cell type item")
   localized_strings['s_escUnknownSheetCmd']=_("Unknown sheet command: ")
   localized_strings['s_escUnknownSetCoordCmd']=_("Unknown set coord command: ")
   localized_strings['s_escUnknownCmd']=_("Unknown command: ")
   localized_strings['s_caccCircRef']=_("Circular reference to ") 
##   localized_strings['defaultRowNameWidth']=_("30")
##   localized_strings['defaultCellIDPrefix']=_("cell_") 
##   localized_strings['defaultCellLayout']=_("padding:2px 2px 1px 2px;vertical-align:top;")
   localized_strings['defaultCellFontStyle']=_("normal normal")
   localized_strings['defaultCellFontSize']=_("small")
##   localized_strings['defaultCellFontFamily']=_("Verdana,Arial,Helvetica,sans-serif")
   localized_strings['s_rcMissingSheet']=_("Render Context must have a sheet object") 
##   localized_strings['defaultLinkFormatString']=_('<span style="font-size:smaller;text-decoration:none !important;background-color:#66B;color:#FFF;">Link</span>') 
##   localized_strings['defaultPageLinkFormatString']=_('<span style="font-size:smaller;text-decoration:none !important;background-color:#66B;color:#FFF;">Page</span>') 
##   localized_strings['defaultFormatdt']=_('d-mmm-yyyy h:mm:ss')
##   localized_strings['defaultFormatd']=_('d-mmm-yyyy')
##   localized_strings['defaultFormatt']=_('[h]:mm:ss')
   localized_strings['defaultDisplayTRUE']=_('TRUE') 
   localized_strings['defaultDisplayFALSE']=_('FALSE')
##   localized_strings['defaultImagePrefix']=_("images/sc-") 
##   localized_strings['defaultTableEditorIDPrefix']=_("te_") 
   localized_strings['s_statusline_executing']=_("Executing...")
   localized_strings['s_statusline_displaying']=_("Displaying...")
   localized_strings['s_statusline_ordering']=_("Ordering...")
   localized_strings['s_statusline_calculating']=_("Calculating...")
   localized_strings['s_statusline_calculatingls']=_("Calculating... Loading Sheet...")
   localized_strings['s_statusline_doingserverfunc']=_("doing server function ")
   localized_strings['s_statusline_incell']=_(" in cell ")
   localized_strings['s_statusline_calcstart']=_("Calculation start...")
   localized_strings['s_statusline_sum']=_("SUM")
##   localized_strings['s_statusline_recalcneeded']=_('<span style="color:#999;">(Recalc needed)</span>')
##   localized_strings['s_statusline_circref']=_('<span style="color:red;">Circular reference: ')
   localized_strings['s_inputboxdisplaymultilinetext']=_("[Multi-line text: Click icon on right to edit]")
   localized_strings['ietUnknownFunction']=_("Unknown function ")
   localized_strings['s_panesliderTooltiph']=_("Drag to lock pane vertically") 
   localized_strings['s_panesliderTooltipv']=_("Drag to lock pane horizontally")    
   localized_strings['s_loc_align_center']=_("Align Center")
   localized_strings['s_loc_align_left']=_("Align Left")
   localized_strings['s_loc_align_right']=_("Align Right")
   localized_strings['s_loc_alignment']=_("Alignment")
   localized_strings['s_loc_audit']=_("Audit")
##   localized_strings['s_loc_audit_trail_thilocalized_strings['s_session']=_("Audit Trail This Session")
   localized_strings['s_loc_auto']=_("Auto")
   localized_strings['s_loc_auto_sum']=_("Auto Sum")
   localized_strings['s_loc_auto_wX_commas']=_("Auto w/ commas")
   localized_strings['s_loc_automatic']=_("Automatic")
   localized_strings['s_loc_background']=_("Background")
   localized_strings['s_loc_bold']=_("Bold")
   localized_strings['s_loc_bold_XampX_italics']=_("Bold &amp; Italics")
   localized_strings['s_loc_bold_italic']=_("Bold Italic")
   localized_strings['s_loc_borders']=_("Borders")
   localized_strings['s_loc_borders_off']=_("Borders Off")
   localized_strings['s_loc_borders_on']=_("Borders On")
   localized_strings['s_loc_bottom']=_("Bottom")
   localized_strings['s_loc_bottom_border']=_("Bottom Border")
   localized_strings['s_loc_cell_settings']=_("CELL SETTINGS")
   localized_strings['s_loc_csv_format']=_("CSV format")
   localized_strings['s_loc_cancel']=_("Cancel")
   localized_strings['s_loc_category']=_("Category")
   localized_strings['s_loc_center']=_("Center")
   localized_strings['s_loc_clear']=_("Clear")
   localized_strings['s_loc_clear_socialcalc_clipboard']=_("Clear SocialCalc Clipboard")
   localized_strings['s_loc_clipboard']=_("Clipboard")
   localized_strings['s_loc_color']=_("Color")
   localized_strings['s_loc_column_']=_("Column ")
   localized_strings['s_loc_comment']=_("Comment")
   localized_strings['s_loc_copy']=_("Copy")
   localized_strings['s_loc_custom']=_("Custom")
   localized_strings['s_loc_cut']=_("Cut")
   localized_strings['s_loc_default']=_("Default")
   localized_strings['s_loc_default_alignment']=_("Default Alignment")
   localized_strings['s_loc_default_column_width']=_("Default Column Width")
   localized_strings['s_loc_default_font']=_("Default Font")
   localized_strings['s_loc_default_format']=_("Default Format")
   localized_strings['s_loc_default_padding']=_("Default Padding")
   localized_strings['s_loc_delete']=_("Delete")
   localized_strings['s_loc_delete_column']=_("Delete Column")
   localized_strings['s_loc_delete_contents']=_("Delete Contents")
   localized_strings['s_loc_delete_row']=_("Delete Row")
   localized_strings['s_loc_description']=_("Description")
   localized_strings['s_loc_display_clipboard_in']=_("Display Clipboard in")
   localized_strings['s_loc_down']=_("Down")
   localized_strings['s_loc_edit']=_("Edit")
   localized_strings['s_loc_existing_names']=_("Existing Names")
   localized_strings['s_loc_family']=_("Family")
   localized_strings['s_loc_fill_down']=_("Fill Down")
   localized_strings['s_loc_fill_right']=_("Fill Right")
   localized_strings['s_loc_font']=_("Font")
   localized_strings['s_loc_format']=_("Format")
   localized_strings['s_loc_formula']=_("Formula")
   localized_strings['s_loc_function_list']=_("Function List")
   localized_strings['s_loc_functions']=_("Functions")
   localized_strings['s_loc_grid']=_("Grid")
   localized_strings['s_loc_hidden']=_("Hidden")
   localized_strings['s_loc_horizontal']=_("Horizontal")
   localized_strings['s_loc_insert_column']=_("Insert Column")
   localized_strings['s_loc_insert_row']=_("Insert Row")
   localized_strings['s_loc_italic']=_("Italic")
   localized_strings['s_loc_last_sort']=_("Last Sort")
   localized_strings['s_loc_left']=_("Left")
   localized_strings['s_loc_left_border']=_("Left Border")
   localized_strings['s_loc_link']=_("Link")
   localized_strings['s_loc_link_input_box']=_("Link Input Box")
   localized_strings['s_loc_list']=_("List")
   localized_strings['s_loc_load_socialcalc_clipboard_with_this']=_("Load SocialCalc Clipboard With This")
   localized_strings['s_loc_major_sort']=_("Major Sort")
   localized_strings['s_loc_manual']=_("Manual")
   localized_strings['s_loc_merge_cells']=_("Merge Cells")
   localized_strings['s_loc_middle']=_("Middle")
   localized_strings['s_loc_minor_sort']=_("Minor Sort")
   localized_strings['s_loc_move_insert']=_("Move Insert")
   localized_strings['s_loc_move_paste']=_("Move Paste")
   localized_strings['s_loc_multiXline_input_box']=_("Multi-line Input Box")
   localized_strings['s_loc_name']=_("Name")
   localized_strings['s_loc_names']=_("Names")
   localized_strings['s_loc_no_padding']=_("No padding")
   localized_strings['s_loc_normal']=_("Normal")
   localized_strings['s_loc_number']=_("Number")
   localized_strings['s_loc_number_horizontal']=_("Number Horizontal")
   localized_strings['s_loc_ok']=_("OK")
   localized_strings['s_loc_padding']=_("Padding")
   localized_strings['s_loc_page_name']=_("Page Name")
   localized_strings['s_loc_paste']=_("Paste")
   localized_strings['s_loc_paste_formats']=_("Paste Formats")
   localized_strings['s_loc_plain_text']=_("Plain Text")
   localized_strings['s_loc_recalc']=_("Recalc")
   localized_strings['s_loc_recalculation']=_("Recalculation")
   localized_strings['s_loc_redo']=_("Redo")
   localized_strings['s_loc_right']=_("Right")
   localized_strings['s_loc_right_border']=_("Right Border")
   localized_strings['s_loc_sheet_settings']=_("SHEET SETTINGS")
   localized_strings['s_loc_save']=_("Save")
   localized_strings['s_loc_save_to']=_("Save to")
   localized_strings['s_loc_set_cell_contents']=_("Set Cell Contents")
   localized_strings['s_loc_set_cells_to_sort']=_("Set Cells To Sort")
   localized_strings['s_loc_set_value_to']=_("Set Value To")
   localized_strings['s_loc_set_to_link_format']=_("Set to Link format")
   localized_strings['s_loc_setXclear_move_from']=_("Set/Clear Move From")
   localized_strings['s_loc_show_cell_settings']=_("Show Cell Settings")
   localized_strings['s_loc_show_sheet_settings']=_("Show Sheet Settings")
   localized_strings['s_loc_show_in_new_browser_window']=_("Show in new browser window")
   localized_strings['s_loc_size']=_("Size")
   localized_strings['s_loc_socialcalcXsave_format']=_("SocialCalc-save format")
   localized_strings['s_loc_sort']=_("Sort")
   localized_strings['s_loc_sort_']=_("Sort ")
   localized_strings['s_loc_sort_cells']=_("Sort Cells")
   localized_strings['s_loc_swap_colors']=_("Swap Colors")
   localized_strings['s_loc_tabXdelimited_format']=_("Tab-delimited format")
   localized_strings['s_loc_text']=_("Text")
   localized_strings['s_loc_text_horizontal']=_("Text Horizontal")
   localized_strings['s_loc_this_is_aXbrXsample']=_("This is a<br>sample")
   localized_strings['s_loc_top']=_("Top")
   localized_strings['s_loc_top_border']=_("Top Border")
   localized_strings['s_loc_undone_steps']=_("UNDONE STEPS")
   localized_strings['s_loc_url']=_("URL")
   localized_strings['s_loc_undo']=_("Undo")
   localized_strings['s_loc_unmerge_cells']=_("Unmerge Cells")
   localized_strings['s_loc_up']=_("Up")
   localized_strings['s_loc_value']=_("Value")
   localized_strings['s_loc_vertical']=_("Vertical")
   localized_strings['s_loc_workspace']=_("Workspace")
   localized_strings['s_loc_XnewX']=_("[New]")
   localized_strings['s_loc_XnoneX']=_("[None]")
   localized_strings['s_loc_Xselect_rangeX']=_("[select range]")
##   localized_strings['FormatNumber_separatorchar']=_(")") // the thousands separator character when formatting numbers for display
##   localized_strings['FormatNumber_decimalchar']=_(".") // the decimal separator character when formatting numbers for display
##   localized_strings['FormatNumber_defaultCurrency']=_("$") // the currency string used if none specified
##   localized_strings['s_FormatNumber_daynames']=_(["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"])
##   localized_strings['s_FormatNumber_daynames3']=_(["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"])
##   localized_strings['s_FormatNumber_monthnames']=_(["January", "February", "March", "April", "May", "June", "July", "August", "September","October", "November", "December"])                             
##   localized_strings['s_FormatNumber_monthnames3']=_(["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"])
##   localized_strings['s_FormatNumber_am']=_("AM")
##   localized_strings['s_FormatNumber_am1']=_("A")
##   localized_strings['s_FormatNumber_pm']=_("PM")
##   localized_strings['s_FormatNumber_pm1']=_("P")
   localized_strings['s_parseerrexponent']=_("Improperly formed number exponent")
   localized_strings['s_parseerrchar']=_("Unexpected character in formula")
   localized_strings['s_parseerrstring']=_("Improperly formed string")
   localized_strings['s_parseerrspecialvalue']=_("Improperly formed special value")
   localized_strings['s_parseerrtwoops']=_("Error in formula (two operators inappropriately in a row)")
   localized_strings['s_parseerrmissingopenparen']=_("Missing open parenthesis in list with comma(s). ")
   localized_strings['s_parseerrcloseparennoopen']=_("Closing parenthesis without open parenthesis. ")
   localized_strings['s_parseerrmissingcloseparen']=_("Missing close parenthesis. ")
   localized_strings['s_parseerrmissingoperand']=_("Missing operand. ")
   localized_strings['s_parseerrerrorinformula']=_("Error in formula.")
   localized_strings['s_calcerrerrorvalueinformula']=_("Error value in formula")
   localized_strings['s_parseerrerrorinformulabadval']=_("Error in formula resulting in bad value")
   localized_strings['s_formularangeresult']=_("Formula results in range value:")
   localized_strings['s_calcerrnumericnan']=_("Formula results in an bad numeric value")
   localized_strings['s_calcerrnumericoverflow']=_("Numeric overflow")
   localized_strings['s_sheetunavailable']=_("Sheet unavailable:") # when FindSheetInCache returns null
   localized_strings['s_calcerrcellrefmissing']=_("Cell reference missing when expected.")
   localized_strings['s_calcerrsheetnamemissing']=_("Sheet name missing when expected.")
   localized_strings['s_circularnameref']=_("Circular name reference to name")
   localized_strings['s_calcerrunknownname']=_("Unknown name")
   localized_strings['s_calcerrincorrectargstofunction']=_("Incorrect arguments to function")
   localized_strings['s_sheetfuncunknownfunction']=_("Unknown function")
   localized_strings['s_sheetfunclnarg']=_("LN argument must be greater than 0")
   localized_strings['s_sheetfunclog10arg']=_("LOG10 argument must be greater than 0")
   localized_strings['s_sheetfunclogsecondarg']=_("LOG second argument must be numeric greater than 0")
   localized_strings['s_sheetfunclogfirstarg']=_("LOG first argument must be greater than 0")
   localized_strings['s_sheetfuncroundsecondarg']=_("ROUND second argument must be numeric")
   localized_strings['s_sheetfuncddblife']=_("DDB life must be greater than 1")
   localized_strings['s_sheetfuncslnlife']=_("SLN life must be greater than 1")
   localized_strings['s_fdef_ABS']=_('Absolute value function. ')
   localized_strings['s_fdef_ACOS']=_('Trigonometric arccosine function. ')
   localized_strings['s_fdef_AND']=_('True if all arguments are true. ')
   localized_strings['s_fdef_ASIN']=_('Trigonometric arcsine function. ')
   localized_strings['s_fdef_ATAN']=_('Trigonometric arctan function. ')
   localized_strings['s_fdef_ATAN2']=_('Trigonometric arc tangent function (result is in radians). ')
   localized_strings['s_fdef_AVERAGE']=_('Averages the values. ')
   localized_strings['s_fdef_CHOOSE']=_('Returns the value specified by the index. The values may be ranges of cells. ')
   localized_strings['s_fdef_COLUMNS']=_('Returns the number of columns in the range. ')
   localized_strings['s_fdef_COS']=_('Trigonometric cosine function (value is in radians). ')
   localized_strings['s_fdef_COUNT']=_('Counts the number of numeric values, not blank, text, or error. ')
   localized_strings['s_fdef_COUNTA']=_('Counts the number of non-blank values. ')
   localized_strings['s_fdef_COUNTBLANK']=_("Counts the number of blank values. (Note: '' is not blank.) ")
   localized_strings['s_fdef_COUNTIF']=_("Counts the number of number of cells in the range that meet the criteria. The criteria may be a value ('x', 15, 1+3) or a test (>25). ")
   localized_strings['s_fdef_DATE']=_('Returns the appropriate date value given numbers for year, month, and day. For example: DATE(2006,2,1) for February 1, 2006. Note: In this program, day 1 is December 31, 1899 and the year 1900 is not a leap year. Some programs use January 1, 1900, as day 1 and treat 1900 as a leap year. In both cases, though, dates on or after March 1, 1900, are the same. ')
   localized_strings['s_fdef_DAVERAGE']=_('Averages the values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DAY']=_('Returns the day of month for a date value. ')
   localized_strings['s_fdef_DCOUNT']=_('Counts the number of numeric values, not blank, text, or error, in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DCOUNTA']=_('Counts the number of non-blank values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DDB']=_('Returns the amount of depreciation at the given period of time (the default factor is 2 for double-declining balance).   ')
   localized_strings['s_fdef_DEGREES']=_('Converts value in radians into degrees. ')
   localized_strings['s_fdef_DGET']=_('Returns the value of the specified field in the single record that meets the criteria. ')
   localized_strings['s_fdef_DMAX']=_('Returns the maximum of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DMIN']=_('Returns the maximum of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DPRODUCT']=_('Returns the result of multiplying the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DSTDEV']=_('Returns the sample standard deviation of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DSTDEVP']=_('Returns the standard deviation of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DSUM']=_('Returns the sum of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DVAR']=_('Returns the sample variance of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_DVARP']=_('Returns the variance of the numeric values in the specified field in records that meet the criteria. ')
   localized_strings['s_fdef_EVEN']=_('Rounds the value up in magnitude to the nearest even integer. ')
   localized_strings['s_fdef_EXACT']=_('Returns true if the values are exactly the same, including case, type, etc. ')
   localized_strings['s_fdef_EXP']=_('Returns e raised to the value power. ')
   localized_strings['s_fdef_FACT']=_('Returns factorial of the value. ')
   localized_strings['s_fdef_FALSE']=_('Returns the logical value false. ')
   localized_strings['s_fdef_FIND']=_('Returns the starting position within string2 of the first occurrence of string1 at or after start. If start is omitted, 1 is assumed. ')
   localized_strings['s_fdef_FV']=_('Returns the future value of repeated payments of money invested at the given rate for the specified number of periods, with optional present value (default 0) and payment type (default 0 = at end of period, 1 = beginning of period). ')
   localized_strings['s_fdef_HLOOKUP']=_('Look for the matching value for the given value in the range and return the corresponding value in the cell specified by the row offset. If rangelookup is 1 (the default) and not 0, match if within numeric brackets (match<=value) instead of exact match. ')
   localized_strings['s_fdef_HOUR']=_('Returns the hour portion of a time or date/time value. ')
   localized_strings['s_fdef_IF']=_('Results in true-value if logical-expression is TRUE or non-zero, otherwise results in false-value. ')
   localized_strings['s_fdef_INDEX']=_('Returns a cell or range reference for the specified row and column in the range. If range is 1-dimensional, then only one of rownum or colnum are needed. If range is 2-dimensional and rownum or colnum are zero, a reference to the range of just the specified column or row is returned. You can use the returned reference value in a range, e.g., sum(A1:INDEX(A2:A10,4)). ')
   localized_strings['s_fdef_INT']=_('Returns the value rounded down to the nearest integer (towards -infinity). ')
   localized_strings['s_fdef_IRR']=_('Returns the interest rate at which the cash flows in the range have a net present value of zero. Uses an iterative process that will return #NUM! error if it does not converge. There may be more than one possible solution. Providing the optional guess value may help in certain situations where it does not converge or finds an inappropriate solution (the default guess is 10%). ')
   localized_strings['s_fdef_ISBLANK']=_('Returns true if the value is a reference to a blank cell. ')
   localized_strings['s_fdef_ISERR']=_('Returns true if the value is of type Error but not NA. ')
   localized_strings['s_fdef_ISERROR']=_('Returns true if the value is of type Error. ')
   localized_strings['s_fdef_ISLOGICAL']=_('Returns true if the value is of type Logical (true/false). ')
   localized_strings['s_fdef_ISNA']=_('Returns true if the value is the error type NA. ')
   localized_strings['s_fdef_ISNONTEXT']=_('Returns true if the value is not of type Text. ')
   localized_strings['s_fdef_ISNUMBER']=_('Returns true if the value is of type Number (including logical values). ')
   localized_strings['s_fdef_ISTEXT']=_('Returns true if the value is of type Text. ')
   localized_strings['s_fdef_LEFT']=_('Returns the specified number of characters from the text value. If count is omitted, 1 is assumed. ')
   localized_strings['s_fdef_LEN']=_('Returns the number of characters in the text value. ')
   localized_strings['s_fdef_LN']=_('Returns the natural logarithm of the value. ')
   localized_strings['s_fdef_LOG']=_('Returns the logarithm of the value using the specified base. ')
   localized_strings['s_fdef_LOG10']=_('Returns the base 10 logarithm of the value. ')
   localized_strings['s_fdef_LOWER']=_('Returns the text value with all uppercase characters converted to lowercase. ')
   localized_strings['s_fdef_MATCH']=_('Look for the matching value for the given value in the range and return position (the first is 1) in that range. If rangelookup is 1 (the default) and not 0, match if within numeric brackets (match<=value) instead of exact match. If rangelookup is -1, act like 1 but the bracket is match>=value. ')
   localized_strings['s_fdef_MAX']=_('Returns the maximum of the numeric values. ')
   localized_strings['s_fdef_MID']=_('Returns the specified number of characters from the text value starting from the specified position. ')
   localized_strings['s_fdef_MIN']=_('Returns the minimum of the numeric values. ')
   localized_strings['s_fdef_MINUTE']=_('Returns the minute portion of a time or date/time value. ')
   localized_strings['s_fdef_MOD']=_('Returns the remainder of the first value divided by the second. ')
   localized_strings['s_fdef_MONTH']=_('Returns the month part of a date value. ')
   localized_strings['s_fdef_N']=_('Returns the value if it is a numeric value otherwise an error. ')
   localized_strings['s_fdef_NA']=_('Returns the #N/A error value which propagates through most operations. ')
   localized_strings['s_fdef_NOT']=_('Returns FALSE if value is true, and TRUE if it is false. ')
   localized_strings['s_fdef_NOW']=_('Returns the current date/time. ')
   localized_strings['s_fdef_NPER']=_('Returns the number of periods at which payments invested each period at the given rate with optional future value (default 0) and payment type (default 0 = at end of period, 1 = beginning of period) has the given present value. ')
   localized_strings['s_fdef_NPV']=_('Returns the net present value of cash flows (which may be individual values and/or ranges) at the given rate. The flows are positive if income, negative if paid out, and are assumed at the end of each period. ')
   localized_strings['s_fdef_ODD']=_('Rounds the value up in magnitude to the nearest odd integer. ')
   localized_strings['s_fdef_OR']=_('True if any argument is true ')
   localized_strings['s_fdef_PI']=_('The value 3.1415926... ')
   localized_strings['s_fdef_PMT']=_('Returns the amount of each payment that must be invested at the given rate for the specified number of periods to have the specified present value, with optional future value (default 0) and payment type (default 0 = at end of period, 1 = beginning of period). ')
   localized_strings['s_fdef_POWER']=_('Returns the first value raised to the second value power. ')
   localized_strings['s_fdef_PRODUCT']=_('Returns the result of multiplying the numeric values. ')
   localized_strings['s_fdef_PROPER']=_('Returns the text value with the first letter of each word converted to uppercase and the others to lowercase. ')
   localized_strings['s_fdef_PV']=_('Returns the present value of the given number of payments each invested at the given rate, with optional future value (default 0) and payment type (default 0 = at end of period, 1 = beginning of period). ')
   localized_strings['s_fdef_RADIANS']=_('Converts value in degrees into radians. ')
   localized_strings['s_fdef_RATE']=_('Returns the rate at which the given number of payments each invested at the given rate has the specified present value, with optional future value (default 0) and payment type (default 0 = at end of period, 1 = beginning of period). Uses an iterative process that will return #NUM! error if it does not converge. There may be more than one possible solution. Providing the optional guess value may help in certain situations where it does not converge or finds an inappropriate solution (the default guess is 10%). ')
   localized_strings['s_fdef_REPLACE']=_('Returns text1 with the specified number of characters starting from the specified position replaced by text2. ')
   localized_strings['s_fdef_REPT']=_('Returns the text repeated the specified number of times. ')
   localized_strings['s_fdef_RIGHT']=_('Returns the specified number of characters from the text value starting from the end. If count is omitted, 1 is assumed. ')
   localized_strings['s_fdef_ROUND']=_('Rounds the value to the specified number of decimal places. If precision is negative, then round to powers of 10. The default precision is 0 (round to integer). ')
   localized_strings['s_fdef_ROWS']=_('Returns the number of rows in the range. ')
   localized_strings['s_fdef_SECOND']=_('Returns the second portion of a time or date/time value (truncated to an integer). ')
   localized_strings['s_fdef_SIN']=_('Trigonometric sine function (value is in radians) ')
   localized_strings['s_fdef_SLN']=_('Returns the amount of depreciation at each period of time using the straight-line method. ')
   localized_strings['s_fdef_SQRT']=_('Square root of the value ')
   localized_strings['s_fdef_STDEV']=_('Returns the sample standard deviation of the numeric values. ')
   localized_strings['s_fdef_STDEVP']=_('Returns the standard deviation of the numeric values. ')
   localized_strings['s_fdef_SUBSTITUTE']=_('Returns text1 with the all occurrences of oldtext replaced by newtext. If occurrence is present, then only that occurrence is replaced. ')
   localized_strings['s_fdef_SUM']=_('Adds the numeric values. The values to the sum function may be ranges in the form similar to A1:B5. ')
   localized_strings['s_fdef_SUMIF']=_("Sums the numeric values of cells in the range that meet the criteria. The criteria may be a value ('x', 15, 1+3) or a test (>25). If range2 is present, then range1 is tested and the corresponding range2 value is summed. ")
   localized_strings['s_fdef_SYD']=_("Depreciation by Sum of Year's Digits method. ")
   localized_strings['s_fdef_T']=_('Returns the text value or else a null string. ')
   localized_strings['s_fdef_TAN']=_('Trigonometric tangent function (value is in radians) ')
   localized_strings['s_fdef_TIME']=_('Returns the time value given the specified hour, minute, and second. ')
   localized_strings['s_fdef_TODAY']=_('Returns the current date (an integer). Note: In this program, day 1 is December 31, 1899 and the year 1900 is not a leap year. Some programs use January 1, 1900, as day 1 and treat 1900 as a leap year. In both cases, though, dates on or after March 1, 1900, are the same. ')
   localized_strings['s_fdef_TRIM']=_('Returns the text value with leading, trailing, and repeated spaces removed. ')
   localized_strings['s_fdef_TRUE']=_('Returns the logical value true. ')
   localized_strings['s_fdef_TRUNC']=_('Truncates the value to the specified number of decimal places. If precision is negative, truncate to powers of 10. ')
   localized_strings['s_fdef_UPPER']=_('Returns the text value with all lowercase characters converted to uppercase. ')
   localized_strings['s_fdef_VALUE']=_('Converts the specified text value into a numeric value. Various forms that look like numbers (including digits followed by %, forms that look like dates, etc.) are handled. This may not handle all of the forms accepted by other spreadsheets and may be locale dependent. ')
   localized_strings['s_fdef_VAR']=_('Returns the sample variance of the numeric values. ')
   localized_strings['s_fdef_VARP']=_('Returns the variance of the numeric values. ')
   localized_strings['s_fdef_VLOOKUP']=_('Look for the matching value for the given value in the range and return the corresponding value in the cell specified by the column offset. If rangelookup is 1 (the default) and not 0, match if within numeric brackets (match>=value) instead of exact match. ')
   localized_strings['s_fdef_WEEKDAY']=_('Returns the day of week specified by the date value. If type is 1 (the default), Sunday is day and Saturday is day 7. If type is 2, Monday is day 1 and Sunday is day 7. If type is 3, Monday is day 0 and Sunday is day 6. ')
   localized_strings['s_fdef_YEAR']=_('Returns the year part of a date value. ')
   localized_strings['s_farg_v']=_("value")
   localized_strings['s_farg_vn']=_("value1, value2, ...")
   localized_strings['s_farg_xy']=_("valueX, valueY")
   localized_strings['s_farg_choose']=_("index, value1, value2, ...")
   localized_strings['s_farg_range']=_("range")
   localized_strings['s_farg_rangec']=_("range, criteria")
   localized_strings['s_farg_date']=_("year, month, day")
   localized_strings['s_farg_dfunc']=_("databaserange, fieldname, criteriarange")
   localized_strings['s_farg_ddb']=_("cost, salvage, lifetime, period [, factor]")
   localized_strings['s_farg_find']=_("string1, string2 [, start]")
   localized_strings['s_farg_fv']=_("rate, n, payment, [pv, [paytype]]")
   localized_strings['s_farg_hlookup']=_("value, range, row, [rangelookup]")
   localized_strings['s_farg_iffunc']=_("logical-expression, true-value, false-value")
   localized_strings['s_farg_index']=_("range, rownum, colnum")
   localized_strings['s_farg_irr']=_("range, [guess]")
   localized_strings['s_farg_tc']=_("text, count")
   localized_strings['s_farg_log']=_("value, base")
   localized_strings['s_farg_match']=_("value, range, [rangelookup]")
   localized_strings['s_farg_mid']=_("text, start, length")
   localized_strings['s_farg_nper']=_("rate, payment, pv, [fv, [paytype]]")
   localized_strings['s_farg_npv']=_("rate, value1, value2, ...")
   localized_strings['s_farg_pmt']=_("rate, n, pv, [fv, [paytype]]")
   localized_strings['s_farg_pv']=_("rate, n, payment, [fv, [paytype]]")
   localized_strings['s_farg_rate']=_("n, payment, pv, [fv, [paytype, [guess]]]")
   localized_strings['s_farg_replace']=_("text1, start, length, text2")
   localized_strings['s_farg_vp']=_("value, [precision]")
   localized_strings['s_farg_valpre']=_("value, precision")
   localized_strings['s_farg_csl']=_("cost, salvage, lifetime")
   localized_strings['s_farg_cslp']=_("cost, salvage, lifetime, period")
   localized_strings['s_farg_subs']=_("text1, oldtext, newtext [, occurrence]")
   localized_strings['s_farg_sumif']=_("range1, criteria [, range2]")
   localized_strings['s_farg_hms']=_("hour, minute, second")
   localized_strings['s_farg_txt']=_("text")
   localized_strings['s_farg_vlookup']=_("value, range, col, [rangelookup]")
   localized_strings['s_farg_weekday']=_("date, [type]")
   localized_strings['s_farg_dt']=_("date")
   localized_strings['s_fclass_all']=_("All")
   localized_strings['s_fclass_stat']=_("Statistics")
   localized_strings['s_fclass_lookup']=_("Lookup")
   localized_strings['s_fclass_datetime']=_("Date & Time")
   localized_strings['s_fclass_financial']=_("Financial")
   localized_strings['s_fclass_test']=_("Test")
   localized_strings['s_fclass_math']=_("Math")
   localized_strings['s_fclass_text']=_("Text")
   
   localized_strings['s_loc_plain']=_("Plain")
   localized_strings['s_loc_graph']=_("Graph")
   localized_strings['s_loc_display_over_edit']=_("Also show in Edit")
   localized_strings['s_loc_cells_to_graph']=_("Cells to Graph")
   localized_strings['s_loc_set_cells_to_graph']=_("Set Cells To Graph")
   localized_strings['s_loc_graph_type']=_("Graph Type")
   localized_strings['s_loc_help']=_("Help")
   localized_strings['s_loc_horizontal_bar']=_("Horizontal Bar")
   localized_strings['s_loc_vertical_bar']=_("Vertical Bar")
   localized_strings['s_loc_pie_chart']=_("Pie Chart")
   localized_strings['s_loc_line_chart']=_("Line Chart")
   localized_strings['s_loc_scatter_chart']=_("Plot Points")
   localized_strings['s_loc_not_set']=_("Not Set")
   localized_strings['s_loc_unknown_range_name']=_("Unknown range name")
   localized_strings['s_loc_hide_help ']=_("Hide Help")
   
   localized_strings['s_loc_x']=_("X ")
   localized_strings['s_loc_y']=_("Y ")
   localized_strings['s_loc_max']=_("Max ")
   localized_strings['s_loc_min']=_("Min ")
   localized_strings['s_loc_ok']=_(" OK ")

   localized_strings['s_PopupListCustom']=_("Custom")
   
   
add_localized_strings()
